/*--------------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        14.06.2007
 Description:    ADC-Routinen
--------------------------------------------------------------------------------*/

#ifndef _ANALOG_H
#define _ANALOG_H

//-----------------------------------------------------------------------------
#include "typedefs.h"
#include "clock-arch.h"
#include <lpc213x.h>
#include "config.h"
#include "fc.h"
//-----------------------------------------------------------------------------

#define VIC_Channel_ADC0  18
#define VIC_Channel_ADC1  21

void ADC_Init(void);
void adc0_int(void);
void adc1_int(void);
void ADC_offset(void);

extern volatile unsigned char adc_on;

extern volatile int adc0_value_mux[];
extern volatile int adc0_count[];
extern volatile int adc0_mittelwert[];
extern volatile int adc0_neutral[];
extern volatile int adc0_pos[];

extern volatile int adc1_value_mux[];
extern volatile int adc1_count[];
extern volatile int adc1_mittelwert[];
extern volatile int adc1_neutral[];
extern volatile int adc1_pos[];
extern volatile int adc_count[];
//-----------------------------------------------------------------------------
//ADC0 Channels
#define	ADC_GIER	0
#define ADC_ACCX	1
#define ADC_ACCZ	2
#define ADC_ACCY	3
#define ADC_NICK	4
#define ADC_ROLL	5

//ADC1 Channels
#define UBAT	3

//-----------------------------------------------------------------------------
#define ANALOG_OFF  adc_on = 0;
#define ANALOG_ON	adc_on = 1;

#endif //_ANALOG_H

