/*--------------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        14.06.2007
 Description:    Timer-Routinen
--------------------------------------------------------------------------------*/
#include "clock-arch.h"

volatile unsigned char speaker_on = 0;
volatile unsigned char speaker_on_int = 0;
volatile unsigned int timer_counter = 0;

//-------------------------------------------------------------------------------
// Timer0 Compare-Match Interrupt Handler (ISR) 
void __attribute__ ((interrupt("IRQ"))) tc1_int(void) 
{	 
	timer_counter++;
	
	if ((adc1_value_mux[UBAT]<480) | (rc_valid < 90)){
	speaker_on_int = ON;
	}else speaker_on_int = OFF;
	
    if(rc_valid < 90)
    {
        if((rc_ch[RC_GAS]+70) > 30) rc_ch[RC_GAS]--;
    }
    
	if((speaker_on > OFF)|(speaker_on_int > OFF))
	{
		if(!(timer_counter % SPEAKER_TONE)) SPEAKER_FLASH;
	}
	else
	{
		SPEAKER_OFF;
	}
	
	T1IR = TxIR_MR0; // Clear interrupt flag by writing 1 to Bit 0
	VICVectAddr = 0;       // Acknowledge Interrupt (rough?)
}

//-------------------------------------------------------------------------------
// Setup Timer0 Compare-Match Interrupt         
// no prescaler timer runs at cclk = FOSC*PLL_M 
void init_timer (void)
{
	//Compare-hit (10Khz)
	T1MR0 = (FOSC*3/TIMER_TEILER1)-1;
	//Interrupt and Reset on MR0
	T1MCR = TxMCR_MR0I | TxMCR_MR0R;	 
	//Timer1 Enable
	T1TCR = TxTCR_COUNTER_ENABLE;            		 

	//set interrupt vector in 0
	VICVectAddr2 = (unsigned long)tc1_int;
	//use it for Timer 1 Interrupt
	VICVectCntl2 = VICVectCntl_ENABLE | VIC_Channel_Timer1;
	//Enable Timer1 Interrupt
	VICIntEnable = (1<<VIC_Channel_Timer1);    
}



