/*-----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        14.06.2007
 Description:    Timer-Routinen
-----------------------------------------------------------------------------*/
#ifndef __TIMER_ARCH_H_
#define __TIMER_ARCH_H_

//-----------------------------------------------------------------------------
#include "typedefs.h"
#include "clock-arch.h"
#include <lpc213x.h>
#include "config.h"

#include "rc.h"
//-----------------------------------------------------------------------------

void tc1_int(void); 
void init_timer(void);

extern volatile unsigned char speaker_on;
extern volatile unsigned char speaker_on_int;
extern volatile unsigned int timer_counter;

#define SPEAKER_TONE 	8
#define ON 				1
#define OFF				0

#define VICVectCntl_ENABLE (1<<5)
#define VIC_Channel_Timer1  5
#define VIC_Channel_Timer0  4

#define TIMER_TEILER0       192
#define TIMER_TEILER1       10000 //10Khz

//Timer Control Register
#define TxTCR_COUNTER_ENABLE (1<<0)
#define TxTCR_COUNTER_RESET  (1<<1)

//Timer Match Control Register
#define TxMCR_MR0I		(1<<0)
#define TxMCR_MR0R		(1<<1)

//Capture Control Register
#define TxCCR_CAP0RE	(1<<0)
#define TxCCR_CAP0FE	(1<<1)
#define TxCCR_CAP0I		(1<<2)
#define TxCCR_CAP1RE	(1<<3)
#define TxCCR_CAP1FE	(1<<4)
#define TxCCR_CAP1I		(1<<5)
#define TxCCR_CAP2RE	(1<<6)
#define TxCCR_CAP2FE	(1<<7)
#define TxCCR_CAP2I		(1<<8)
#define TxCCR_CAP3RE	(1<<9)
#define TxCCR_CAP3FE	(1<<10)
#define TxCCR_CAP3I		(1<<11)

//Interrupt Flags Register TxIR
//Clear interrupt flag by writing 1 to Bit 0
#define TxIR_MR0	(1<<0)
#define TxIR_MR1	(1<<1)
#define TxIR_MR2	(1<<2)
#define TxIR_MR3	(1<<3)
#define TxIR_CR0	(1<<4)
#define TxIR_CR1	(1<<5)
#define TxIR_CR2	(1<<6)
#define TxIR_CR3	(1<<7)

#endif


