/*------------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        14.06.2007
 Description:    Config BL-UFO
------------------------------------------------------------------------------*/
#ifndef _CONFIG_H_
 #define _CONFIG_H_

//-------------------------------------------------------------------------------
 /* System Config */
#define FOSC		10000000
// max. speed  = 60 MHz
#define PLL_M		6                 
#define MSEL		(PLL_M-1)
#define PSEL0 		5
#define PSEL1 		6

#define PLLE		0
#define PLLC		1

#define PLOCK		10

#define PLL_FEED1	0xAA
#define PLL_FEED2	0x55

#define MAM_MODE 	2
#define MAM_FETCH   3
	
#define VPBDIV_VAL	1

// Interrupt vectors are re-mapped to Boot Block.
#define MEMMAP_BOOT_LOADER_MODE   0  
// Interrupt vectors are not re-mapped and reside in Flash.     
#define MEMMAP_USER_FLASH_MODE    (1<<0) 
// Interrupt vectors are re-mapped to Static RAM. 
#define MEMMAP_USER_RAM_MODE      (1<<1)  


//-------------------------------------------------------------------------------
//Hardware Led Grn Rot und Speaker
#define ROT_OFF   IOPIN1 &= ~(1<<21); 
#define ROT_ON    IOPIN1 |= (1<<21); 
#define ROT_FLASH IOPIN1 ^= (1<<21);

#define GRN_OFF   IOPIN1 &= ~(1<<22);
#define GRN_ON    IOPIN1 |= (1<<22); 
#define GRN_FLASH IOPIN1 ^= (1<<22);

#define SPEAKER_OFF   IOPIN1 &= ~(1<<27);
#define SPEAKER_ON    IOPIN1 |= (1<<27); 
#define SPEAKER_FLASH IOPIN1 ^= (1<<27);
	
#endif //_CONFIG_H_
