/*------------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        14.06.2007
 Description:    RC Routinen
------------------------------------------------------------------------------*/
#include "rc.h"

volatile unsigned char rc_channel_counter = 0;
volatile unsigned int rc_valid;
volatile signed char rc_ch[RC_MAX_CHANNEL] = {0,0,0,0};
volatile signed char rc_ch_tmp[RC_MAX_CHANNEL] = {0,0,0,0};
volatile unsigned int OldTimerValue = 0;
volatile unsigned int TimerValue = 0;	

//-------------------------------------------------------------------------------
//zum decodieren des PPM-Signals wird Timer0 mit seiner Input
//Capture Funktion benutzt:
void rc_sum_init (void)
{
	//P0.16 als Capture 0.2 (Timer0)
	PINSEL1 |= (1<<0)|(1<<1);   
	//Interrupt bei rising edge
	T0CCR |= TxCCR_CAP2RE|TxCCR_CAP2I;	
	//Timer0 Prescale Register
	T0PR = TIMER_TEILER0;	
	//Timer0 Enable
	T0TCR = TxTCR_COUNTER_ENABLE;            		 
	//set interrupt vector in 1
	VICVectAddr1 = (unsigned long)tc0_cap2;
	//use it for Timer 0 Interrupt
	VICVectCntl1 = VICVectCntl_ENABLE | VIC_Channel_Timer0; 
	//Enable Timer0 Interrupt
	VICIntEnable = (1<<VIC_Channel_Timer0);    	
    return;
}

//-------------------------------------------------------------------------------
//Diese Routine startet und inizialisiert den Timer fr RC
void __attribute__ ((interrupt("IRQ"))) tc0_cap2(void) 
{
	TimerValue = T0CR2 - OldTimerValue;
	OldTimerValue = T0CR2;

	if (TimerValue < RC_MIN_VALUE){
		rc_channel_counter = 0;
		if(rc_valid != 0) rc_valid--;
		T0IR = TxIR_CR2;	// Clear interrupt flag by writing 1 to Bit 0
		VICVectAddr = 0;	// Acknowledge Interrupt (rough?)
		return;
		}
		
	if (TimerValue > RC_MAX_VALUE)
    {
        if(rc_channel_counter < RC_MAX_CHANNEL && rc_channel_counter > 4)
        {
            if (rc_valid > 90)
            {
                for(unsigned char a = 0;a<4;a++)
                {
                    rc_ch[a] = rc_ch_tmp[a];
                }
            }
            rc_valid++;
        }
        else
        {
            if(rc_valid != 0) rc_valid--;
            rc_ch[RC_NICK] = 0;
            rc_ch[RC_ROLL] = 0;
            rc_ch[RC_GIER] = 0;
        }
		rc_channel_counter = 0;
		
	}  
	else
	{
        if (TimerValue > RC_MIN_VALUE)
        {
            rc_ch_tmp[rc_channel_counter]= (TimerValue - RC_OFFSET);
            if (((signed int)(TimerValue - RC_OFFSET))> 127) rc_ch_tmp[rc_channel_counter]=  127;
            if (((signed int)(TimerValue - RC_OFFSET))<-127) rc_ch_tmp[rc_channel_counter]= -127;
     
            if(rc_channel_counter++ > RC_MAX_CHANNEL)
            {
                if(rc_valid != 0) rc_valid--;
                rc_channel_counter=0;
            }
        }
        else
        {
            if(rc_valid != 0) rc_valid--;
            rc_channel_counter=0;
        }
	}
	if (rc_valid>100) rc_valid = 100;
	
	T0IR = TxIR_CR2;	// Clear interrupt flag by writing 1 to Bit 0
	VICVectAddr = 0;	// Acknowledge Interrupt (rough?)
}







