/*-----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        14.06.2007
 Description:    I2C Routinen
-----------------------------------------------------------------------------*/
#ifndef _I2C_MASTER_H
#define _I2C_MASTER_H

//-----------------------------------------------------------------------------
#include "typedefs.h"
#include "clock-arch.h"
#include <lpc213x.h>
#include "config.h"
#include "fc.h"
//-----------------------------------------------------------------------------

#define VIC_Channel_I2C0  9

//I2C Control Set Register
#define AA		(1<<2)
#define SI		(1<<3)
#define STO		(1<<4)
#define STA		(1<<5)
#define I2EN	(1<<6)

extern unsigned char twi_state;
extern unsigned char motor;
extern volatile unsigned char PWM_Motor[4];

// I2C initialisieren
void i2c_init (void); 
// Start I2C
char i2c_start (void); 
// Stop I2C
void i2c_stop (void);
// 1 Byte schreiben 
char i2c_write_byte (char byte); 
// ISR Routine
void i2c_int(void);

void motor_off(void); 

#endif
